<?php

namespace App\ViewModels\Administrativo\AdministrativoRegistrationViewModel;
use App\Utils\Builder;
use App\Utils\ResponseException;
use Config\CustomRules;
use Exception;

class AdministrativoRegistrationViewModelBuilder implements Builder
{
    protected $foto;
    protected $nome;
    protected $email;
    protected $rg;
    protected $data_nascimento;
    protected $cpf;
    protected $genero;
    protected $telefone_1;
    protected $telefone_2;
    protected $numero;
    protected $complemento;
    protected $referencias;
    protected $profissao;
    protected $estado_civil;
    protected $indicado_por;
    protected $adicionado_por;
    protected $senha;
    protected $token_confirmacao_email;
    protected $ativo;
    protected $id_medico;
    protected $id_perfil;
    protected $id_clinica;

    protected $cep;
    protected $logradouro;
    protected $cidade;
    protected $bairro;
    protected $estado;

    /**
     * @param mixed $id_clinica
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setIdClinica($id_clinica)
    {
        $this->id_clinica = $id_clinica;
        return $this;
    }

    /**
     * @param mixed $id_perfil
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setIdPerfil($id_perfil)
    {
        $this->id_perfil = $id_perfil;
        return $this;
    }

    public function setFoto($foto)
    {
        $this->foto = $foto;
        return $this;
    }

    public function setNome(string $nome): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_ONLY_LETTERS_SPACES, $nome)) {
            throw new ResponseException(['nome' => 'Informe um nome válido.']);
        }
        $this->nome = $nome;
        return $this;
    }

    public function setEmail(string $email): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_EMAIL, $email)) {
            throw new ResponseException(['email' => 'Informe um email válido.']);
        }
        $this->email = $email;
        return $this;
    }

    public function setRg(string $rg): AdministrativoRegistrationViewModelBuilder
    {
        $this->rg = $rg;
        return $this;
    }

    public function setDataNascimento(string $data_nascimento): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_DATE_US_PATTERN, $data_nascimento)) {
            throw new ResponseException(['data_nascimeneto' => 'Informe uma data válida.']);
        }
        $this->data_nascimento = $data_nascimento;
        return $this;
    }

    public function setCpf(string $cpf): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_CPF, $cpf)) {
            throw new ResponseException(['cpf' => 'Informe um CPF válido.']);
        }
        $this->cpf = $cpf;
        return $this;
    }

    public function setGenero(string $genero): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_GENERO, $genero)) {
            throw new ResponseException(['genero' => 'Informe um gênero válido.']);
        }
        $this->genero = $genero;
        return $this;
    }

    public function setTelefone1(string $telefone_1): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_PHONE, $telefone_1)) {
            throw new ResponseException(['telefone_1' => 'Informe um telefone_1 válido.']);
        }
        $this->telefone_1 = $telefone_1;
        return $this;
    }

    public function setTelefone2(string $telefone_2): AdministrativoRegistrationViewModelBuilder
    {
        if ($telefone_2 && !preg_match(REGEX_PHONE, $telefone_2)) {
            throw new ResponseException(['telefone_2' => 'Informe um telefone_1 válido.']);
        }
        $this->telefone_2 = $telefone_2;
        return $this;
    }

    public function setCep(string $cep): AdministrativoRegistrationViewModelBuilder
    {
        if (!preg_match(REGEX_CEP, $cep)) {
            throw new ResponseException(['cep' => 'Informe um CEP válido.']);
        }
        $this->cep = $cep;
        return $this;
    }

    public function setNumero(string $numero): AdministrativoRegistrationViewModelBuilder
    {
        $this->numero = $numero;
        return $this;
    }

    public function setComplemento(string $complemento): AdministrativoRegistrationViewModelBuilder
    {
        $this->complemento = $complemento;
        return $this;
    }

    public function setReferencias(string $referencias): AdministrativoRegistrationViewModelBuilder
    {
        $this->referencias = $referencias;
        return $this;
    }

    public function setProfissao(string $profissao): AdministrativoRegistrationViewModelBuilder
    {
        $this->profissao = $profissao;
        return $this;
    }

    public function setEstadoCivil(string $estado_civil): AdministrativoRegistrationViewModelBuilder
    {
        $this->estado_civil = $estado_civil;
        return $this;
    }

    public function setIndicadoPor(string $indicado_por): AdministrativoRegistrationViewModelBuilder
    {
        $this->indicado_por = $indicado_por;
        return $this;
    }

    public function setAdicionadoPor(?int $adicionado_por): AdministrativoRegistrationViewModelBuilder
    {
        $this->adicionado_por = $adicionado_por;
        return $this;
    }

    public function setSenha(string $senha): AdministrativoRegistrationViewModelBuilder
    {
        $this->senha = $senha;
        return $this;
    }

    public function setTokenConfirmacaoEmail(string $token_confirmacao_email): AdministrativoRegistrationViewModelBuilder
    {
        $this->token_confirmacao_email = $token_confirmacao_email;
        return $this;
    }

    public function setAtivo(int $ativo): AdministrativoRegistrationViewModelBuilder
    {
        $this->ativo = $ativo;
        return $this;
    }

    public function setIdMedico(int $id_medico):AdministrativoRegistrationViewModelBuilder
    {
        $this->id_medico = $id_medico;
        return $this;
    }

    /**
     * @param mixed $logradouro
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setLogradouro($logradouro)
    {
        $this->logradouro = $logradouro;
        return $this;
    }

    /**
     * @param mixed $cidade
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setCidade($cidade)
    {
        $this->cidade = $cidade;
        return $this;
    }

    /**
     * @param mixed $bairro
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setBairro($bairro)
    {
        $this->bairro = $bairro;
        return $this;
    }

    /**
     * @param mixed $estado
     * @return AdministrativoRegistrationViewModelBuilder
     */
    public function setEstado($estado)
    {
        $this->estado = $estado;
        return $this;
    }






    public function build () {
        $paciente_registration_view_model = new AdministrativoRegistrationViewModel();
        $paciente_registration_view_model->setFoto($this->foto);
        $paciente_registration_view_model->setnome($this->nome);
        $paciente_registration_view_model->setemail($this->email);
        $paciente_registration_view_model->setrg($this->rg);
        $paciente_registration_view_model->setdatanascimento($this->data_nascimento);
        $paciente_registration_view_model->setcpf($this->cpf);
        $paciente_registration_view_model->setgenero($this->genero);
        $paciente_registration_view_model->settelefone1($this->telefone_1);
        $paciente_registration_view_model->settelefone2($this->telefone_2);
        $paciente_registration_view_model->setcep($this->cep);
        $paciente_registration_view_model->setnumero($this->numero);
        $paciente_registration_view_model->setcomplemento($this->complemento);
        $paciente_registration_view_model->setreferencias($this->referencias);
        $paciente_registration_view_model->setprofissao($this->profissao);
        $paciente_registration_view_model->setestadocivil($this->estado_civil);
        $paciente_registration_view_model->setindicadopor($this->indicado_por);
        $paciente_registration_view_model->setAdicionadoPor($this->adicionado_por);
        $paciente_registration_view_model->setSenha($this->senha);
        $paciente_registration_view_model->settokenconfirmacaoemail($this->token_confirmacao_email);
        $paciente_registration_view_model->setIdMedico($this->id_medico);
        $paciente_registration_view_model->setAtivo($this->ativo);
        $paciente_registration_view_model->setLogradouro($this->logradouro);
        $paciente_registration_view_model->setCidade($this->cidade);
        $paciente_registration_view_model->setEstado($this->estado);
        $paciente_registration_view_model->setBairro($this->bairro);
        $paciente_registration_view_model->setIdPerfil($this->id_perfil);
        $paciente_registration_view_model->setIdClinica($this->id_clinica);
        return $paciente_registration_view_model;
    }
}
